int zeit;
int zz;
int messint;
wordaddress;
int feucht[12];
int temp[14];
int werttemp;
int wertfeucht;
int wertlicht;
int wertregen;
int wertwind;
float wtemp;
float wfeucht;
float wzwischen;
float wlicht;
float wregen;
byte jalesen;
byte windr[3];

void main(void)
{
zeit=0;
zz=0;
messint=0;
I2C_Init(I2C_100kHz);

Setupstation();
address=0x10;

regen();
feuchte();
licht();
temperatur();
wind();
Umrechnung();


schreibenstart();
schreiben(messint);
schreiben(wertfeucht);
schreiben(werttemp);
schreiben(wertlicht);
schreiben(wertregen);
schreiben(wertwind);
schreibenstop(12);


Irq_SetVect(INT_TIM2COMP,Befehl);

while(true);
}

void Umrechnung(void)
{

wtemp=werttemp;
wzwischen=wertfeucht;
wlicht=wertlicht;
wregen=wertregen;



wtemp=(wtemp*0.01)-40.0;
wfeucht=-(wzwischen*wzwischen*2.8*0.001*0.001);
wfeucht=wfeucht+(wzwischen*0.0405)-4.0;
wfeucht=(wtemp-25.0)*(0.01+0.00008*wzwischen)+wfeucht;

werttemp=wtemp*100.0;
wertfeucht=wfeucht*100.0;

wlicht=wlicht*5/1024;
wlicht=wlicht/7;
wlicht=(((1-wlicht)/(wlicht*10))-(1/24));
wlicht=wlicht*600;
wertlicht=wlicht;

wregen=wregen*5/1024;
wregen=wregen/7;
wregen=(((1-wregen)/wregen*10)-(1/24));
wregen=wregen*100;
Msg_WriteHex(43690);
wregen=wregen-1684;
wregen=wregen/3.42;
wregen=wregen*100;
wertregen=wregen;
if (wertregen==0)
{
wertregen=-1;
}




Msg_WriteInt(wertfeucht);
Msg_WriteHex(43690);
Msg_WriteInt(werttemp);
Msg_WriteHex(43690);
Msg_WriteInt(wertlicht);
Msg_WriteHex(43690);
Msg_WriteInt(wertregen);
Msg_WriteHex(43690);
Msg_WriteInt(wertwind);
Msg_WriteHex(43690);

}


void Befehl(void)
{
intirqcnt;





if (zz==100*messint)
{
zeit=zeit+1;
zz=0;

regen();
feuchte();
licht();
temperatur();
wind();
Umrechnung();

schreibenstart();
schreiben(wertfeucht);
schreiben(werttemp);
schreiben(wertlicht);
schreiben(wertregen);
schreiben(wertwind);
schreibenstop(10);



}
else
{
zz=zz+1;
}


irqcnt=Irq_GetCount(INT_TIM2COMP);
}

void Clock(void)
{
Port_WriteBit(18,1);
AbsDelay(1);
Port_WriteBit(18,0);
AbsDelay(1);
}

void portschreiben(int y)
{
Port_WriteBit(21,0);
Port_WriteBit(20,y);
}

void licht(void)
{
ADC_Set(ADC_VREF_VCC,0);
wertlicht=ADC_Read();

}


void wind(void)
{
Port_DataDirBit(8,0);
Port_DataDirBit(9,0);
Port_DataDirBit(10,0);
windr[0]=Port_ReadBit(10);
windr[1]=Port_ReadBit(9);
windr[2]=Port_ReadBit(8);
wertwind=1;
if (windr[0]!=0)
{
wertwind=2;
}
if (windr[1]!=0)
{
wertwind=3;
}
if (windr[2]!=0)
{
wertwind=4;
}


}


void regen(void)
{
ADC_Set(ADC_VREF_VCC,1);
wertregen=ADC_Read();
}

void feuchte(void)
{
int checken;
int messen;
int i;

Port_DataDirBit(18,1);
Port_DataDirBit(19,0);
Port_DataDirBit(20,1);
Port_DataDirBit(21,1);

portschreiben(1);

AbsDelay(1);
Port_WriteBit(18,1);
AbsDelay(1);
portschreiben(0);
AbsDelay(1);
Port_WriteBit(18,0);                   //Transmission Start
AbsDelay(1);
Port_WriteBit(18,1);
AbsDelay(1);
portschreiben(1);
AbsDelay(1);
Port_WriteBit(18,0);
AbsDelay(1);

portschreiben(0);
AbsDelay(1);
Clock();
Clock();
Clock();
Clock();
Clock();
portschreiben(1);
AbsDelay(1);
Clock();                                    //Code fr Feuchtigkeit 00000101
portschreiben(0);
AbsDelay(1);
Clock();
portschreiben(1);
AbsDelay(1);
Port_WriteBit(18,1);
AbsDelay(1);
Port_WriteBit(18,0);
Port_WriteBit(21,1);

AbsDelay(1);

checken=1;
while(checken==1)
{
messen=Port_ReadBit(19);
if (messen==0)
{                                          //Ack.
Clock();
checken=0;
}
}

AbsDelay(1);



checken=1;
while(checken==1)
{
messen=Port_ReadBit(19);               //Warten fr Messung
AbsDelay(1);
if (messen==0)
{
checken=0;
}
}

Clock();
Clock();
Clock();
Clock();

for(i=0;i<4;i++)
{
messen=Port_ReadBit(19);                    //erste 4Bit
AbsDelay(1);
feucht[i]=messen;
Clock();
}


AbsDelay(1);
portschreiben(0);                            //Ack.
AbsDelay(1);
Port_WriteBit(18,1);
AbsDelay(1);

Port_WriteBit(18,0);
Port_WriteBit(21,1);
AbsDelay(1);

for(i=0;i<8;i++)
{
messen=Port_ReadBit(19);                    //nchte 8 bit
AbsDelay(1);
feucht[i+4]=messen;
Clock();
}


AbsDelay(1);
portschreiben(0);
AbsDelay(1);                     // Verbindung trennen
Port_WriteBit(18,1);
AbsDelay(1);
portschreiben(1);

wertfeucht=0;
for (i=0;i<12;i++)
{
//Msg_WriteInt(feucht[i]);
wertfeucht=wertfeucht+(feucht[i]<<(11-i));
}

}



void temperatur(void)
{
int checken;
int messen;
int i;

Port_DataDirBit(18,1);
Port_DataDirBit(19,0);
Port_DataDirBit(20,1);
Port_DataDirBit(21,1);

portschreiben(1);

AbsDelay(1);
Port_WriteBit(18,1);
AbsDelay(1);
portschreiben(0);
AbsDelay(1);
Port_WriteBit(18,0);                   //Transmission Start
AbsDelay(1);
Port_WriteBit(18,1);
AbsDelay(1);
portschreiben(1);
AbsDelay(1);
Port_WriteBit(18,0);
AbsDelay(1);

portschreiben(0);
AbsDelay(1);
Clock();
Clock();
Clock();
Clock();
Clock();
Clock();
portschreiben(1);
AbsDelay(1);
Clock();                                    //Code fr Temp 00000011
portschreiben(1);
AbsDelay(1);
Port_WriteBit(18,1);
AbsDelay(1);
Port_WriteBit(18,0);
Port_WriteBit(21,1);


AbsDelay(1);

checken=1;
while(checken==1)
{
messen=Port_ReadBit(19);
if (messen==0)
{                                          //Ack.
Clock();
checken=0;
}
}

AbsDelay(1);


checken=1;
while(checken==1)
{
messen=Port_ReadBit(19);               //Warten fr Messung
AbsDelay(1);
if (messen==0)
{
checken=0;
}
}

Clock();
Clock();


for(i=0;i<6;i++)
{
messen=Port_ReadBit(19);                    //erste 6Bit
AbsDelay(1);
temp[i]=messen;
Clock();
}


AbsDelay(1);
portschreiben(0);                            //Ack.
AbsDelay(1);
Port_WriteBit(18,1);
AbsDelay(1);
Port_WriteBit(18,0);
Port_WriteBit(21,1);
AbsDelay(1);

for(i=0;i<8;i++)
{
messen=Port_ReadBit(19);                    //nchte 8 bit
AbsDelay(1);
temp[i+6]=messen;
Clock();
}


AbsDelay(1);
portschreiben(0);
AbsDelay(1);                     // Verbindung trennen
Port_WriteBit(18,1);
AbsDelay(1);
portschreiben(1);

werttemp=0;
for (i=0;i<14;i++)
{
//Msg_WriteInt(temp[i]);

werttemp=werttemp+(temp[i]<<(13-i));
}



}






void Setupstation(void)
{
byte fertig;
word key_in;
byte key_ch;
int pos;

LCD_Init();
Key_Init();
LCD_ClearLCD();
LCD_CursorOff();


LCD_CursorPos(0);
LCD_WriteChar('g');
LCD_CursorPos(1);
LCD_WriteChar('e');
LCD_CursorPos(2);
LCD_WriteChar('t');
LCD_CursorPos(3);
LCD_WriteChar(' ');
LCD_CursorPos(4);
LCD_WriteChar('d');
LCD_CursorPos(5);
LCD_WriteChar('a');
LCD_CursorPos(6);
LCD_WriteChar('t');
LCD_CursorPos(7);
LCD_WriteChar('a');

LCD_CursorPos(0x40);
LCD_WriteChar('1');
LCD_CursorPos(0x41);
LCD_WriteChar('=');
LCD_CursorPos(0x42);
LCD_WriteChar('y');
LCD_CursorPos(0x43);
LCD_WriteChar('e');
LCD_CursorPos(0x44);
LCD_WriteChar('s');

fertig=0;
jalesen=0;

while (fertig==0)
{
key_in=Key_Scan();
if (key_in!=0)
{
key_ch=Key_TranslateKey(key_in);
LCD_CursorPos(12);
LCD_WriteChar(key_ch);
key_ch=key_ch-48;
if (key_ch==1)
{

jalesen=1;
fertig=1;
}
else
{
fertig=1;
}

}
}



if (jalesen==1)
   {
LCD_ClearLCD();
LCD_CursorOff();


LCD_CursorPos(0);
LCD_WriteChar('2');
LCD_CursorPos(2);
LCD_WriteChar('=');
LCD_CursorPos(4);
LCD_WriteChar('U');
LCD_CursorPos(5);
LCD_WriteChar('S');
LCD_CursorPos(6);
LCD_WriteChar('B');

LCD_CursorPos(0x40);
LCD_WriteChar('3');
LCD_CursorPos(0x42);
LCD_WriteChar('=');
LCD_CursorPos(0x44);
LCD_WriteChar('C');
LCD_CursorPos(0x45);
LCD_WriteChar('O');
LCD_CursorPos(0x46);
LCD_WriteChar('M');

fertig=0;



while (fertig==0)
{
key_in=Key_Scan();
if (key_in!=0)
{
key_ch=Key_TranslateKey(key_in);
LCD_CursorPos(12);
LCD_WriteChar(key_ch);
key_ch=key_ch-48;
if (key_ch==2)
{
speicherholen(1);
fertig=1;
}
else
{
if (key_ch==3)
{
speicherholen(2);
fertig=1;
}
}

}
}

   }


   
fertig=0;

LCD_ClearLCD();
LCD_CursorOff();
LCD_CursorPos(0);
LCD_WriteChar('M');
LCD_CursorPos(1);
LCD_WriteChar('e');
LCD_CursorPos(2);
LCD_WriteChar('s');
LCD_CursorPos(3);
LCD_WriteChar('s');
LCD_CursorPos(4);
LCD_WriteChar('i');
LCD_CursorPos(5);
LCD_WriteChar('n');
LCD_CursorPos(6);
LCD_WriteChar('t');
LCD_CursorPos(7);
LCD_WriteChar('.');
LCD_CursorPos(0x47);
LCD_WriteChar('s');

pos=0;
while (fertig==0)
{
AbsDelay(500);
key_in=Key_Scan();
if (key_in!=0)
{
key_ch=Key_TranslateKey(key_in);
LCD_CursorPos(12);
LCD_WriteChar(key_ch);
if (key_ch!=35)
{
pos=pos+1;
key_ch=key_ch-48;
LCD_CursorPos(0x40+pos);
LCD_WriteChar('0'+key_ch);
messint=messint*hoch(pos-1);
messint=messint+key_ch;
}
else
{
fertig=1;
}
}
}


LCD_ClearLCD();
LCD_CursorOff();
LCD_CursorPos(0);
LCD_WriteChar('S');
LCD_CursorPos(1);
LCD_WriteChar('t');
LCD_CursorPos(2);
LCD_WriteChar('a');
LCD_CursorPos(3);
LCD_WriteChar('r');
LCD_CursorPos(4);
LCD_WriteChar('t');
LCD_CursorPos(5);
LCD_WriteChar('e');
LCD_CursorPos(6);
LCD_WriteChar('n');
LCD_CursorPos(0x40);
LCD_WriteChar('1');
LCD_CursorPos(0x41);
LCD_WriteChar('=');
LCD_CursorPos(0x42);
LCD_WriteChar('l');
LCD_CursorPos(0x43);
LCD_WriteChar('o');
LCD_CursorPos(0x44);
LCD_WriteChar('s');


fertig=0;

while (fertig==0)
{
key_in=Key_Scan();
if (key_in!=0)
{
key_ch=Key_TranslateKey(key_in);
LCD_CursorPos(12);
LCD_WriteChar(key_ch);
key_ch=key_ch-48;
if (key_ch==1)
{
fertig=1;
LCD_ClearLCD();
LCD_CursorOff();

}
}
}



}

int hoch(int x)
{
int i;
int a;
a=1;
for(i=1;i<x+1;i++)
{
a=a*10;
}
return a;
}

byte ausgabe1;
byte ausgabe2;
int anzeige;

void speicherholen(byte ziel)
{

if (ziel==2)
{
Serial_Init(0,SR_8BIT|SR_1STOP|SR_NO_PAR,SR_BD19200);
}

address=0x10;

I2C_Start();
 
I2C_Write(0xA0);
     I2C_Write(address>>8);

   I2C_Write(address);

   I2C_Start();


   I2C_Write(0xA1);

do{


ausgabe1=I2C_Read_ACK();
  ausgabe2=I2C_Read_ACK();
  anzeige=ausgabe1<<8;
  anzeige=anzeige+ausgabe2;

  if (ziel==1)
  {
  if (anzeige!=0)
  {
  Msg_WriteInt(anzeige);
  Msg_WriteHex(43690);
  }
  }
  else
  {
  Serial_Write(0,ausgabe1);
  Serial_Write(0,ausgabe2);
  }
       }
while (anzeige!=0);

 ausgabe1=I2C_Read_NACK();
  ausgabe2=I2C_Read_NACK();
I2C_Stop();
   if (ziel==2)
{

Serial_Write(0,0);
Serial_Write(0,0);
Serial_Write(0,0);
Serial_Write(0,0);
Serial_Disable(0);
}

}



void schreibenstart(void)
{
I2C_Start();
I2C_Write(0xA0);

I2C_Write(address>>8);
I2C_Write(address);
      }

void schreiben(int data)
{
byte a;
a=data>>8;

I2C_Write(a);

a=data;

I2C_Write(a);
     }

void schreibenstop(int bytezahl)
{
byte a;
a=0;
I2C_Write(a);
I2C_Write(a);
I2C_Stop();
address=address+bytezahl;
}


